//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfxgmail.com"

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    DeepSkyBlue
#property indicator_color2    Red
#property indicator_width1    2
#property indicator_minimum  -5
#property indicator_maximum 105
#property indicator_level1   80
#property indicator_level2   20
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int  HMAPeriod             = 50;
extern int  HMAPrice              =  0;
extern int  HMAMethod             = MODE_LWMA;
extern int  SignalPeriod          = 10;
extern bool UseMomentum           = false;
extern bool UseCumulativeMomentum = true;
extern int  NormalizingPeriods    = 50;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int HalfPeriod;
int HullPeriod;

int init()
{
   HMAPeriod  = MathMax(2,HMAPeriod);
   HalfPeriod = MathFloor(HMAPeriod/2);
   HullPeriod = MathFloor(MathSqrt(HMAPeriod));
   
   //
   //
   //
   //
   //
   
   IndicatorBuffers(5);
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);
      SetIndexBuffer(2,buffer3);
      SetIndexBuffer(3,buffer4);
      SetIndexBuffer(4,buffer5);
   IndicatorShortName("HMA oscillator ("+HMAPeriod+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double alpha = 2.0 / (1.0 + SignalPeriod);
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) buffer5[i] = iMA(NULL,0,HalfPeriod,0,HMAMethod,HMAPrice,i)*2.0-
                                        iMA(NULL,0,HMAPeriod ,0,HMAMethod,HMAPrice,i);
   for(i=limit; i>=0; i--)
   {
      buffer4[i] = iMAOnArray(buffer5,0,HullPeriod,0,HMAMethod,i);
      buffer3[i] = 0;
         if (UseMomentum)
            if (UseCumulativeMomentum)
                  for (int k = 0; k<HMAPeriod; k++) buffer3[i] += (buffer4[i+k]-buffer4[i+HMAPeriod+k]);
            else  buffer3[i] = (buffer4[i]-buffer4[i+HMAPeriod]);
         else     buffer3[i] =  buffer4[i];

      //
      //
      //
      //
      //
      
      double hi = buffer3[ArrayMaximum(buffer3,NormalizingPeriods,i)];
      double lo = buffer3[ArrayMinimum(buffer3,NormalizingPeriods,i)];
         if (hi != lo)
               buffer1[i] = 100*(buffer3[i]-lo)/(hi-lo);
         else  buffer1[i] = 0.00;
         buffer2[i] = buffer2[i+1] + alpha*(buffer1[i]-buffer2[i+1]);
   }         
   return(0);
}